SystemOrganization addCategory: #ConfigurationOfMaClientServer!

Object subclass: #ConfigurationOfMaClientServer
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMaClientServer'!

!ConfigurationOfMaClientServer class methodsFor: 'development support' stamp: 'MiguelCoba 2/19/2011 14:31'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfMaClientServer class methodsFor: 'private' stamp: 'MiguelCoba 2/19/2011 14:31'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfMaClientServer class methodsFor: 'private' stamp: 'MiguelCoba 2/19/2011 14:31'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfMaClientServer class methodsFor: 'private' stamp: 'MiguelCoba 2/19/2011 14:31'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfMaClientServer class methodsFor: 'metacello tool support' stamp: 'MiguelCoba 2/19/2011 14:31'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMaClientServer class methodsFor: 'loading' stamp: 'MiguelCoba 2/19/2011 14:31'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfMaClientServer class methodsFor: 'loading' stamp: 'MiguelCoba 2/19/2011 14:31'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfMaClientServer class methodsFor: 'loading' stamp: 'MiguelCoba 2/19/2011 14:31'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfMaClientServer class methodsFor: 'accessing' stamp: 'MiguelCoba 2/19/2011 14:31'!
project

	^self new project! !

!ConfigurationOfMaClientServer class methodsFor: 'development support' stamp: 'MiguelCoba 2/19/2011 14:31'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfMaClientServer methodsFor: 'baselines' stamp: 'MiguelCoba 4/21/2011 02:47'!
baseline13: spec
	<version: '1.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.squeaksource.com/MaClientServer'.
		spec 
			project: 'MaBase' with: [
				spec
					className: 'ConfigurationOfMaBase';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'OSProcess' with: [
				spec
					className: 'ConfigurationOfOSProcess';
					versionString: #'stable';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			package: 'Ma client server';
			package: 'Ma Armored Code' with: [
				spec requires: #('Ma client server' ). ];
			package: 'Ma client server tester' with: [
				spec requires: #('Ma Armored Code' ). ].
		spec group: 'default' with: #('Ma client server tester' 'OSProcess' 'MaBase' ). ].! !

!ConfigurationOfMaClientServer methodsFor: 'symbolic versions' stamp: 'MiguelCoba 2/19/2011 23:07'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: #'notDefined'.
! !

!ConfigurationOfMaClientServer methodsFor: 'accessing' stamp: 'MiguelCoba 2/19/2011 14:31'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfMaClientServer methodsFor: 'symbolic versions' stamp: 'MiguelCoba 2/19/2011 23:07'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.3'.
! !

!ConfigurationOfMaClientServer methodsFor: 'versions' stamp: 'MiguelCoba 4/21/2011 00:38'!
version13: spec
	<version: '1.3' imports: #('1.3-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: '- release version 1.3'.
		spec author: 'MiguelCoba'.
		spec timestamp: '2/19/2011 14:50'.
		spec 
			project: 'MaBase' with: '1.0';
			project: 'OSProcess' with: '4.4.0'.
		spec 
			package: 'Ma client server' with: 'Ma client server-cmm.217';
			package: 'Ma Armored Code' with: 'Ma Armored Code-cmm.150';
			package: 'Ma client server tester' with: 'Ma client server tester-cmm.22'. ]
! !
